IFNDEF __MACROS_INC__
__MACROS_INC__ = 1

_DEBUG = 1

PERF_ON	MACRO
IFNDEF __PERF__
.DATA
	__PERF__ = 1
	__perfBuffer	BYTE	12	DUP (0)
	__perfFmt		BYTE	"%ld", 0
	__perfTitle		BYTE	"Performance counter", 0
ENDIF
.CODE
	pushad
	rdtsc
	push	eax
ENDM

PERF_OFF	MACRO
	rdtsc
	pop		ecx
	sub		eax, ecx
	INVOKE	wsprintfA, ADDR __perfBuffer, ADDR __perfFmt, eax	
	INVOKE	MessageBox, NULL, ADDR __perfBuffer, ADDR __perfTitle, MB_OK
	xor		ebx, ebx
	mov		DWORD PTR __perfBuffer, ebx
	mov		DWORD PTR __perfBuffer[4], ebx
	mov		DWORD PTR __perfBuffer[8], ebx
	popad
ENDM

CTEXT MACRO text:VARARG
    LOCAL TxtName

    .data
     TxtName BYTE text,0
    .code

  EXITM <OFFSET TxtName>
ENDM

Debug	MACRO fmt:REQ, vars:VARARG 
	; from huh's macro 
	LOCAL TxtName

	IFDEF _DEBUG

		; avoid multiple definitions 
		IFNDEF __DEBUG_MACRO__
			.DATA
		__DEBUG_MACRO_BUFFER BYTE 512 DUP (?)
		__DEBUG_MACRO_TITLE BYTE "Debug", 0
		__DEBUG_MACRO__ = 1
			.CODE
		ENDIF

		; huh's macro
		.DATA
		TxtName BYTE fmt,0
		.CODE

		pushad
		; clear buffer
		push eax
		push ecx
		push edi
		xor eax, eax
		mov ecx, 512/4
		mov edi, offset __DEBUG_MACRO_BUFFER
		rep stosd
		pop edi
		pop ecx
		pop eax

		IFB <&vars>
			;// write message directly
			INVOKE MessageBox, NULL, ADDR TxtName, ADDR __DEBUG_MACRO_TITLE, MB_OK
		ELSE 
			;// use wsprintf and write message
			INVOKE wsprintf, ADDR __DEBUG_MACRO_BUFFER, ADDR TxtName, &vars
			INVOKE MessageBox, NULL, ADDR __DEBUG_MACRO_BUFFER, ADDR __DEBUG_MACRO_TITLE, MB_OK
		ENDIF

		popad
	ENDIF
ENDM

;// Assert macro

Assert	MACRO	cdt:REQ, msg:REQ, arg:VARARG
	LOCAL TxtName

	IFDEF _DEBUG
		.DATA
		TxtName	BYTE msg, 0
		.CODE
		.IF ( ! (&cdt) )
			Debug	msg, arg
			INVOKE	ExitProcess, 0
		.ENDIF
	ENDIF
ENDM

ENDIF