.686
.MODEL  FLAT, STDCALL
OPTION CASEMAP:NONE

;/*******************************************
; INCLUDE
;********************************************/

INCLUDE windows.inc
INCLUDE kernel32.inc
INCLUDE user32.inc
INCLUDE comctl32.inc 
INCLUDE gdi32.inc 


INCLUDE macros.inc
INCLUDE main.inc
INCLUDE graphics.inc
INCLUDE board.inc
INCLUDE ai.inc
INCLUDE resource.inc


;/*******************************************
; CONST
;********************************************/

;// Status bar id
MAIN_IDCSTATUS = 1

;/*******************************************
; DATA
;********************************************/

.DATA

WindowName		BYTE    "P4", 0
ClassName		BYTE    "P4Class", 0

ALIGN 4

;// globales main

MainStruct MAINSTRUCT <>

;// message

Msg MSG <>

;// table des sauts menu

MenuJumpTable DWORD DestroyMessage, MenuRestart, MainChangeDifficulty, MainChangeDifficulty, MainChangeDifficulty

;// message status

IDMSG_PLAYER1TURN = 0
IDMSG_PLAYER2TURN = 1
IDMSG_PLAYER1WIN = 2
IDMSG_PLAYER2WIN = 3
IDMSG_DRAW = 4

StatusMsg	DWORD CTEXT("It's your turn")
			DWORD CTEXT("Let me think...")
			DWORD CTEXT("You win !")
			DWORD CTEXT("I win !")
			DWORD CTEXT("Draw !")

;// style window
WINDOW_STYLE = (WS_OVERLAPPEDWINDOW OR WS_CAPTION OR WS_SYSMENU OR WS_SIZEBOX OR WS_MINIMIZEBOX OR WS_MAXIMIZEBOX)
WINDOW_EXSTYLE = WS_EX_CLIENTEDGE

;// dimension min client area
MAIN_MINWIDTH = BOARD_NBCOL * 10
MAIN_MINHEIGHT = BOARD_NBROW * 20

TEST_ESTIM=0

IF TEST_ESTIM
dwtoa  PROTO :DWORD,:DWORD   ; value - buffer
ENDIF

;/*******************************************
; CODE
;********************************************/

.CODE


;/*************************************
;* Resume : Point d'entree
;**************************************/

Main :

		push	0
		call	GetModuleHandle

		mov		MainStruct.HInstance, eax

WinMain:

		mov		ebx, SIZEOF(WNDCLASSEX)
		sub		esp, ebx

	    mov		edi, esp
		xor		eax, eax		
		mov		ecx, ebx
		rep		stosb

		mov		edi, esp
		mov		[edi].WNDCLASSEX.cbSize, ebx
		mov		[edi].WNDCLASSEX.style, CS_OWNDC OR CS_VREDRAW OR CS_HREDRAW
		mov		[edi].WNDCLASSEX.lpszClassName, OFFSET ClassName
		mov		[edi].WNDCLASSEX.lpfnWndProc, P4WndProc
		mov		[edi].WNDCLASSEX.lpszMenuName, IDR_MENU

		xor		esi, esi
		ZERO_REGISTER TEXTEQU <esi>

		push	IDI_APPLICATION
		push	ZERO_REGISTER
		call	LoadIcon

		mov		[edi].WNDCLASSEX.hIcon, eax
		mov		[edi].WNDCLASSEX.hIconSm, eax

		push	IDC_ARROW
		push	ZERO_REGISTER
		call	LoadCursor

		mov		[edi].WNDCLASSEX.hCursor, eax

		mov		ebx, OFFSET MainStruct
		ASSUME	ebx:PTRMAINSTRUCT

		push	edi
		call	RegisterClassEx

		add		esp, SIZEOF(WNDCLASSEX)

		test	eax, eax
		jz		SystemExit

		push	ZERO_REGISTER
		push	[ebx].HInstance
		push	NULL
		push	ZERO_REGISTER
		mov		edx, CW_USEDEFAULT
		push	edx
		push	edx
		push	edx
		push	edx
		push	WINDOW_STYLE
		push	OFFSET WindowName
		push	OFFSET ClassName
		push	WINDOW_EXSTYLE
		call	CreateWindowEx

		xor		edi, edi
		add		edi, eax
		jz		SystemExit

		push	SW_SHOWNORMAL
		push	edi
		call	ShowWindow

		push	edi
		call	UpdateWindow

		mov		edi, OFFSET Msg

MessageLoop :

		push	ZERO_REGISTER
		push	ZERO_REGISTER
		push	ZERO_REGISTER
		push	edi
		call	GetMessage

		test	eax, eax
		jz		SystemExit
		inc		eax
		jz		SystemExit

		push	edi
		call	TranslateMessage

		push	edi
		call	DispatchMessage
		
		jmp		MessageLoop

SystemExit :

		push	Msg.wParam
		call	ExitProcess

;/*************************************
;* Resume : Traitement message
;**************************************/
P4WndProc::

		push	ebx
		push	esi
		push	edi

PARAM_LPARAM TEXTEQU <[esp+4*4+3*4]>
PARAM_WPARAM TEXTEQU <[esp+4*3+3*4]>
PARAM_MSG	 TEXTEQU <[esp+4*2+3*4]>
PARAM_HWND	 TEXTEQU <[esp+4*1+3*4]>

		mov		eax, PARAM_MSG

		cmp		eax, WM_LBUTTONDOWN
		je		MouseMessage

		cmp		eax, WM_USER
		je		UserMessage

		cmp		eax, WM_PAINT
		je		PaintMessage

		cmp		eax, WM_COMMAND
		je		CommandMessage

		cmp		eax, WM_CREATE
		je		CreateMessage

		cmp		eax, WM_KEYDOWN
		je		KeyMessage

		cmp		eax, WM_SIZE
		je		SizeMessage

		cmp		eax, WM_SIZING
		je		SizingMessage

		cmp		eax, WM_DESTROY
		je		DestroyMessage

		pop		edi
		pop		esi
		pop		ebx

		jmp		DefWindowProc

ExitWndProc :

		pop		edi
		pop		esi
		pop		ebx
		
		ret		(4*4)

ExitZero :

		xor		eax, eax
		jmp		ExitWndProc

;// Mouse message

MouseMessage :

		;// eax = col
		mov		ecx, GraphicsStruct.SquareWidth
		xor		edx, edx
		mov		eax, PARAM_LPARAM
		and		eax, 0FFFFh
        sub     eax, GraphicsStruct.OffsetX
        idiv	ecx
		
		lea		edx, [eax - BOARD_NBCOL]
		xor		edx, eax
		jns		ExitZero

OnClick :
	
        call	BoardClick

IF TEST_ESTIM

        jmp     ExitZero

ENDIF ;// TEST_ESTIM


        mov     ebx, eax
        call	UpdateStatusBar
        mov     eax, ebx

        cmp		eax, BOARD_PLAYER2TURN
		ja		GameOver
		jne		ExitZero
        
        ;// desactive menu
        mov     eax, MF_GRAYED
        call    MainEnableDifficulty
        
        call    AiGetMove

		jmp     ExitZero

GameOver :

		push	MB_YESNO OR MB_ICONQUESTION
		push	StatusMsg[4*eax - 4]
		push	CTEXT("Play again ?")
		push	MainStruct.Hwnd
		call	MessageBox

		cmp		eax, IDNO
		je		DestroyMessage

		jmp		MenuRestart


;// Paint message 

PaintMessage :

		mov		ecx, PARAM_WPARAM
		mov		edx, PARAM_LPARAM
		mov		eax, PARAM_MSG

		push	edx
		push	ecx
		push	eax
		push	MainStruct.Hstatus
		call	SendMessage

PaintScreen :

		call	GraphicsPaint

		push	0
		push	MainStruct.Hwnd
		call	ValidateRect

		jmp		ExitZero

;// User message

UserMessage :

        ;// desactive menu
        mov     eax, MF_ENABLED
        call    MainEnableDifficulty

        mov     eax, PARAM_WPARAM
        jmp     OnClick

;// Sizing message
SizingMessage :

        mov     ebx, PARAM_LPARAM
        ASSUME  ebx:PTR RECT

        mov     eax, [ebx].bottom
        sub     eax, [ebx].top
        sub     eax, MainStruct.MinHeight
        jge     @F

        sub     [ebx].bottom, eax

@@ :

        mov     eax, [ebx].right
        sub     eax, [ebx].left
        sub     eax, MainStruct.MinWidth
        jge     ExitZero

        sub     [ebx].right, eax

        jmp     ExitZero

        ASSUME  ebx:NOTHING

;// Size message
SizeMessage :
	
		cmp		DWORD PTR PARAM_WPARAM, SIZE_MINIMIZED
		je		ExitZero

		mov		ecx, PARAM_WPARAM
		mov		edx, PARAM_LPARAM

		push	edx
		push	ecx
		push	eax
		push	MainStruct.Hstatus
		call	SendMessage

		call	GraphicsSize

		jmp		ExitZero

;// Create message

CreateMessage :

        ;// init modules
		mov		eax, PARAM_HWND
		call    MainInit
		call	GraphicsInit
		call	BoardInit
		call	AiInit

		test	eax, eax	
		jz		DestroyMessage

		jmp		ExitZero

;// Command message

CommandMessage :

		mov		eax, PARAM_WPARAM
		and		eax, 0FFFFh
		jmp		MenuJumpTable[4*eax - 4*MAIN_FIRSTMENUID]
				
MenuRestart::

		call	BoardInit

		mov		eax, BOARD_PLAYER1TURN
		call	UpdateStatusBar
		
		jmp		PaintScreen

;// Key message
KeyMessage :

IF TEST_ESTIM
EXTERNDEF BoardNote:DWORD
.DATA
buffer BYTE 256 DUP (0)
fmt     BYTE "note1 = %d", 0
.CODE
        
        push    BoardNote[0]
        push    OFFSET fmt
        push    OFFSET buffer
        call    wsprintf

        add     esp, 3*4
        
        push    0
        push    0
        push    OFFSET buffer
        push    0
        call    MessageBox       

        jmp     ExitZero

ENDIF ;// TEST_ESTIM

        mov     eax, PARAM_WPARAM
		cmp		eax, DWORD PTR VK_ESCAPE
		jne		ExitZero

		;// fall through

;// Destroy message

DestroyMessage ::

		;// destroy graphics
		call	GraphicsQuit
		
		;// destroy ai
		call	AiQuit

		push	NULL
		call	PostQuitMessage

		jmp		ExitZero

;/*************************************
;* Resume : Met a jour la status bar
;* Params : EAX : status du jeu
;**************************************/

UpdateStatusBar::

		push	StatusMsg[4*eax - 4]
		push	0
		push	SB_SETTEXT
		push	MainStruct.Hstatus
		call	SendMessage

		ret


;/*************************************
;* Resume : Change le niveau de difficulte
;* Params : EAX : nouveau niveau
;**************************************/

.DATA

ALIGN 4

;// associe difficulte->profondeur
PlyTable    DWORD   AIPLY_EASY, AIPLY_MEDIUM, AIPLY_HARD

.CODE

MainChangeDifficulty ::
        
        ;// decoche l'ancien
        push    MF_UNCHECKED
        push    MainStruct.Difficulty
        push    MainStruct.HMenu
        call    CheckMenuItem

        ;// change la profondeur de recherche
        mov     eax, PARAM_WPARAM

        mov     MainStruct.Difficulty, eax

        push    PlyTable[4*eax - 4*ID_GAME_LEVEL_EASY]
        pop     AiStruct.Ply      

        ;// coche le nouveau
        push    MF_CHECKED
        push    eax
        push    MainStruct.HMenu
        call    CheckMenuItem

        jmp     ExitZero


;/*************************************
;* Resume : Appele a l'init
;* Params : EAX : handle window
;* Retour: le hdc
;**************************************/

MainInit ::

        mov     MainStruct.Hwnd, eax
		
        ;// init status bar
        mov		ebx, SIZEOF(INITCOMMONCONTROLSEX)
		sub		esp, ebx
		mov		[esp].INITCOMMONCONTROLSEX.dwSize, ebx
		mov		[esp].INITCOMMONCONTROLSEX.dwICC, ICC_BAR_CLASSES
		push	esp
		call	InitCommonControlsEx
		add		esp, ebx

		mov		ebx, OFFSET MainStruct
		ASSUME	ebx:PTR MAINSTRUCT

		push	MAIN_IDCSTATUS
		push	[ebx].Hwnd
		push	StatusMsg[4*IDMSG_PLAYER1TURN]
		push	WS_CHILD+WS_VISIBLE
		call	CreateStatusWindow
		mov		[ebx].Hstatus, eax

        ;// init min rect
        sub     esp, SIZEOF(RECT)
        push    esp
        push    eax
        call    GetClientRect

        mov     esi, [esp].RECT.bottom

        mov     [esp].RECT.right, MAIN_MINWIDTH
        mov     [esp].RECT.bottom, MAIN_MINHEIGHT

        mov     eax, esp
        push    WINDOW_EXSTYLE
        push    1        
        push    WINDOW_STYLE
        push    eax
        call    AdjustWindowRectEx

        add     esi, [esp].RECT.bottom
        mov     edi, [esp].RECT.right
        sub     edi, [esp].RECT.left

        add     esp, SIZEOF(RECT)

        mov     [ebx].MinHeight, esi
        mov     [ebx].MinWidth, edi
		
        ;// init difficulte
        mov     [ebx].Difficulty, ID_GAME_LEVEL_MEDIUM

        push    [ebx].Hwnd
        call    GetMenu
        mov     [ebx].HMenu, eax

        push	[ebx].Hwnd
		call	GetDC

        ret

;/*************************************
;* Resume : Active/Desactive le menu difficulty et restart
;* Params : MF_GRAYED pour desactiver, MF_ENABLED pour activer
;**************************************/

MainEnableDifficulty ::

        push    ebx
        push    esi

        mov     ebx, ID_GAME_START
        mov     esi, eax

@@ :
        push    esi
        push    ebx
        push    MainStruct.HMenu
        call    EnableMenuItem
        inc     ebx
        cmp     ebx, ID_GAME_LEVEL_HARD
        jle     @B


        pop     esi
        pop     ebx

        ret


END Main